this.name               = "aad-hud_eta";
this.author               = "Spara";
this.copyright            = "2013 Mika Spåra";
this.licence     = "CC BY-NC-SA 3.0";
this.description         = "Digital eta display";
this.version            = "2.1";

//2.1 variable to toggle status yellow display on or off
//2.1 bugfix on digit 8

this.startUp = function() {
	//User variables start here
	this.$showEtaOnYellow = true;//Show ETA on condition yellow
	//User variables end here
	this.$cond = "";//player condition flag
	this.$prevDigits = [];//array for previously drawn digits so that only changed digits are drawnp
}

//Turn ETA on, if switching to main screen and not docked.
this.guiScreenChanged = function(to, from) {
	if (player.ship.docked) return;
	if (to === "GUI_SCREEN_MAIN") this.$showEta();
	else {
		this.$stopTimer();
		this.$hideEta();
	}
}

//Turn ETA off when entering hyperspace or docking
this.shipWillEnterWitchspace = this.shipWillDockWithStation = function() {
	this.$stopTimer();
	this.$hideEta();	
}

//Handle different conditions and eta
this.alertConditionChanged = function(newCondition, oldCondition) {
	this.$cond = "";//yellow condition
	if (newCondition === 1) this.$cond = "G";//green condition
	//switch to condition green or yellow state, turn on eta
	if (oldCondition !== 0 && (newCondition === 1 || newCondition === 2)) {
		this.$showEta();
	}
	//switch to condition red, turn off eta
	if ((oldCondition === 1 || oldCondition === 2) && newCondition === 3) {
		this.$stopTimer();
		this.$hideEta();
	}
}

//Turn ETA on.
this.shipLaunchedFromStation = this.shipExitedWitchspace = this.$showEta = function() {
	if (player.alertCondition === 2 && !this.$showEtaOnYellow) {
		this.$stopTimer();
		this.$hideEta();
		return;
	}
	if (player.ship.equipmentStatus("EQ_ADVANCED_COMPASS") === "EQUIPMENT_OK" && guiScreen === "GUI_SCREEN_MAIN") {
		this.$stopTimer();
		this.$prevDigits = [];
		this.$blankEta();
		this.$startTimer();
	}
}

//Empty ETA
this.$blankEta = function() {
	if (this.$prevDigits[0] === -1) return;
	this.$hideEta();
	var i;
	for (i = 0; i < 6; i++)
		player.ship.awardEquipment("EQ_AADHUD_"+i+"5"+this.$cond);
	player.ship.awardEquipment("EQ_AADHUD_DOTS"+this.$cond);
	this.$prevDigits = [-1,-1,-1,-1,-1,-1];//-1 stands for --:--:--
}

//Remove ETA from screen
this.$hideEta = function() {
	var i, j;
	player.ship.removeEquipment("EQ_AADHUD_DOTS");
	player.ship.removeEquipment("EQ_AADHUD_DOTSG");
	for (i = 0; i < 6; i++) {
		for (j = 0; j < 7; j++) {
			player.ship.removeEquipment("EQ_AADHUD_"+i+j);
			player.ship.removeEquipment("EQ_AADHUD_"+i+j+"G");
		}
	}
	this.$prevDigits = [];//zero size array stands for removed eta
}

//Handle drawing digits
this.$displayDigit = function(place, digit) { //place = 0, 1, 2, 3, 4 or 5
	if (this.$prevDigits[place] === digit) return;
	else this.$prevDigits[place] = digit;
	switch(digit) {
    case 1:
		player.ship.removeEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 2:
		player.ship.removeEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 3:
		player.ship.removeEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 4:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;		
    case 5:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;		
    case 6:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);		
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 7:
		player.ship.removeEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 8:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);		
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 9:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.removeEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"5"+this.$cond);		
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;
    case 0:
		player.ship.awardEquipment("EQ_AADHUD_"+place+"0"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"1"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"2"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"3"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"4"+this.$cond);		
		player.ship.removeEquipment("EQ_AADHUD_"+place+"5"+this.$cond);
		player.ship.awardEquipment("EQ_AADHUD_"+place+"6"+this.$cond);
		break;		
  }	
}

//eta calculations
this.$updateEta = function() {
	if (!player.ship.compassTarget) {
		this.$hideEta();
		this.$stopTimer();
		return;
	}
	var compTarget = player.ship.compassTarget;
	var distInM = player.ship.position.distanceTo(compTarget) - compTarget.collisionRadius;
	var vPtoT = compTarget.position.subtract(player.ship.position);
	if (player.ship.velocity.dot(vPtoT) > 0.1 && distInM > 0) {
		var vVelPtoT = vPtoT.multiply(player.ship.velocity.dot(vPtoT) / (vPtoT.dot(vPtoT)));
		var timeToTarget = Math.floor(distInM / vVelPtoT.magnitude());
		if (timeToTarget > 356400) {//case where time is > 99 h.
			this.$blankEta();
			return;
		}
		var hours = Math.floor(timeToTarget / 3600);
		var mins = Math.floor((timeToTarget - 3600 * hours) / 60);
		var secs = Math.floor(timeToTarget - hours * 3600 - mins * 60);
		var tens = Math.floor(hours / 10);
		var ones = hours - tens * 10;
		this.$displayDigit(0, tens);
		this.$displayDigit(1, ones);
		tens = Math.floor(mins / 10);
		ones = mins - tens * 10;
		this.$displayDigit(2, tens);
		this.$displayDigit(3, ones);
		tens = Math.floor(secs / 10);
		ones = secs - tens * 10;
		this.$displayDigit(4, tens);
		this.$displayDigit(5, ones);
	}
	else this.$blankEta();
}

//hide eta, if ASC gets damaged
this.equipmentDamaged = this.equipmentDestroyed = function(equipment) {
	if (equipment === "EQ_ADVANCED_COMPASS") {
		this.$hideEta();
		this.$stopTimer();
	}
}

//show eta, if ASC gets repaired
this.equipmentRepaired = function(equipment) {
	if (equipment === "EQ_ADVANCED_COMPASS" && !player.ship.docked) {
		this.$showEta();
	}	
}

//Timer functions
this.$startTimer = function() {
	if (!this.$etaTimer)
		this.$etaTimer = new Timer(this, this.$updateEta, 0, 1);
	else this.$etaTimer.start();
};

this.$stopTimer = function() {
	if (this.$etaTimer) {
		this.$etaTimer.stop();
		delete this.$etaTimer;
	}
};
